#include "board.h"

Board:: Board(){// first player is the up in the board
        memset(board,0,sizeof board);
        for(int i=1;i<8;i+=2){
                board[0][i]=1;
                board[2][i]=1;
                board[6][i]=-1;
        }
        for(int i=0;i<8;i+=2){
                board[1][i]=1;
                board[5][i]=-1;
                board[7][i]=-1;
        }
        turn=1;
}

int Board:: inf(){
        return 100000;
}

int Board:: eps(){
        return 6;
}

void Board:: change_turn(){
        turn=0-turn;
}

int Board::mysgn(int x){
        if(x<0) return -1;
        if(x>0) return 1;
        return 0;
}

bool Board:: is_valid(int x,int y){
        if(x<0 || x>7 || y<0 || y>7){
                return false;
        }
        return true;
}

void Board:: remove_piece(int x,int y){
        board[x][y]=0;
}

int Board:: piece(int x,int y){
        return board[x][y];
}

void Board:: put(int x,int y,int p){
        if (board[x][y]!=0)
                remove_piece(x,y);
        board[x][y]=p;
}


int Board:: find_amount(int x){
        int ret=0;
        for(int i=0;i<8;i++){
                for(int j=0;j<8;j++){
                        if(board[i][j]==x){
                                ret++;
                        }
                }
        }
        return ret;
}

int Board:: can_hit(int x,int y){
        int ret=0;
        int moves[4][2]={{1,-1},{1,1},{-1,-1},{-1,1}};
        for(int i=0;i<4;i++){
                if(i==2 && abs(board[x][y])!=2){//is king
                        break;
                }
                int nowx=x+moves[i][0],nowy=y+moves[i][1];
                if(is_valid(nowx,nowy)==1 && mysgn(board[x][y])==-mysgn(board[nowx][nowy])){
                        nowx+=moves[i][0];
                        nowy+=moves[i][1];
                        if(is_valid(nowx,nowy)==1 && board[nowx][nowy]==0){
                                ret++;
                        }
                }
        }
        return ret;
}

int Board:: defend(int x,int y){
        int ret=0;
        int moves[4][2]={{1,-1},{1,1},{-1,-1},{-1,1}};
        for(int i=0;i<4;i++){
                int nowx,nowy;
                nowx=x+moves[i][0];
                nowy=y+moves[i][1];
                if( is_valid(x,y)==1 && mysgn(board[x][y])==mysgn(board[nowx][nowy]) ){
                        ret++;
                }
        }
        return ret;
}

bool Board:: is_finished(){// all we need to do is to see if the player that its his/her turn can move or not
        int moves[4][2]={{1,-1},{1,1},{-1,-1},{-1,1}};
        for(int i=0;i<8;i++){
                for(int j=0;j<8;j++){
                        if(board[i][j]<=0){
                                continue;
                        }
                        for(int k=0;k<4;k++){
                                if(board[i][j]!=2 && k==2){//move 2 and 3 is for a king piece so we check it
                                        break;
                                }
                                int nowx,nowy;
                                nowx=i+moves[k][0];
                                nowy=j+moves[k][1];
                                if(is_valid(nowx,nowy)==0){
                                        continue;
                                }
                                if(board[nowx][nowy]==0){//is empty
                                        return 0;
                                }
                                if(board[nowx][nowy]<0){//enemy's piece
                                        nowx+=moves[k][0];
                                        nowy+=moves[k][1];
                                        if(is_valid(nowx,nowy)==0){
                                                continue;
                                        }
                                        if(board[nowx][nowy]==0){
                                                return 0;
                                        }
                                }
                        }
                }
        }
        return 1;
}


int Board:: value(){
        if(turn==-1){//we switch the board and call it for player 1 so we have better and easier code
                Board secondary;
                for(int i=0;i<8;i++){
                        for(int j=0;j<8;j++){
                                secondary.board[7-i][7-j]=-board[i][j];
                        }
                }
                return -secondary.value();
        }
        if(is_finished()==1){
                return inf();
        }
        int val=0;
        /****************************************/ // number of pieces
        int numw,numb,kingB,kingW;
        numw=find_amount(1);
        numb=find_amount(-1);
        kingB=find_amount(-2);
        kingW=find_amount(2);
        val+=200*((2*kingW+numw)-(2*kingB+numb));
        /***************************************/
        if(board[6][7]==1){//its one hundred percent a king with nice place that nobody can attack it
                val+=20;
        }
        if(board[5][0]==1){//it will be a king if we play wisely, and can disabe a piece of our oponent
                val+=15;
        }

        if(board[1][0]==-1){
                val-=20;
        }
        if(board[2][7]==-1){
                val-=15;
        }
        for(int i=0;i<7;i++){//sides of the board cant be attacked and they are strategic
                val+=mysgn(board[i][0])*10;
                val+=mysgn(board[i][7])*10;
        }
        for(int i=0;i<8;i++){//offending position
                for(int j=0;j<8;j++){
                        if(board[i][j]==0){
                                continue;
                        }
                        int num_hit=can_hit(i,j);
                        while(num_hit>0){//we give points to choices we have but we reduce the point given for variety of choices
                                if(board[i][j]<0){
                                        val-=((5-num_hit)*10)-5;
                                }else{
                                        val+=((5-num_hit)*10);
                                }
                                num_hit--;
                        }
                }
        }
        for(int i=0;i<8;i++){//defending position
                for(int j=0;j<8;j++){
                        int defender=defend(i,j);
                        if(board[i][j]==0){
                                continue;
                        }
                        /*
                        if(board[i][j]>0){//because its positives turn defending is not very important
                                val+=mysgn(board[i][j])*15*defender;
                        }else{//defending for the one who its not his turn is very important so we give more points
                                val+=mysgn(board[i][j])*20*defender;
                        }*/
                        if(board[i][j]<0){//because its positives turn defending is important for negative
                                val+=mysgn(board[i][j])*10*defender;
                        }
                }
        }
        return val;
}


void Board:: show(){
        cerr<<endl;
        for(int j=0;j<8;j++){
                cerr<<"- ";
        }
        cerr<<endl;
        for(int i=0;i<8;i++){
                for(int j=0;j<8;j++){
                        if(board[i][j]==0){
                                cerr<<" ";
                        }else if(board[i][j]==-1){
                                cerr<<"o";
                        }else if(board[i][j]==-2){
                                cerr<<"O";
                        }else if(board[i][j]==1){
                                cerr<<"x";
                        }else if(board[i][j]==2){
                                cerr<<"X";
                        }else{
                                cerr<<board[i][j]<<endl;
                        }
                        cerr<<"|";
                }
                cerr<<endl;
                for(int j=0;j<8;j++){
                        cerr<<"- ";
                }
                cerr<<endl;
        }
        cerr<<endl;
}

int Board::turn_player() {
        return turn;
}

int Board:: num_piece(){
        int ret=0;
        for(int i=0;i<8;i++){
                for(int j=0;j<8;j++){
                        if(board[i][j]!=0){
                                ret++;
                        }
                }
        }
        return ret;
}

