#ifndef CHECKERSUI_H
#define CHECKERSUI_H

#include <QMainWindow>
#include <QModelIndex>
#include "player.h"

namespace Ui {
    class CheckersUI;
}

class CheckersUI : public QMainWindow {
    Q_OBJECT
public:
    Board cur_board;
    Player player[2];
    int clickedx, clickedy;
    bool is_clicked;
    int theme;
    int dif_player1;
    int dif_player2;
    bool started;
    CheckersUI(QWidget *parent = 0);
    ~CheckersUI();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::CheckersUI *ui;
    void refresh_board();
    void set_warn(int);
    void start_game();

private slots:
    void on_theme3_clicked();
    void on_actionMario_triggered();
    void on_actionExpert_2_triggered();
    void on_actionHard_2_triggered();
    void on_actionMedium_2_triggered();
    void on_actionEasy_2_triggered();
    void on_actionExpert_triggered();
    void on_actionHard_triggered();
    void on_actionMedium_triggered();
    void on_actionEasy_triggered();
    void on_theme2_clicked();
    void on_theme1_clicked();
    void on_actionWooden_triggered();
    void on_actionDizzy_triggered();
    void on_actionAbout_triggered();
    void on_actionExit_triggered();
    void on_start_game_clicked(bool checked);
    void on_actionNew_game_triggered();
    void on_Playground_cellClicked(int , int);
    void update();

};

#endif // CHECKERSUI_H
