#include "move.h"

Move::Move() {
        first[0] = first[1] = second[0] = second[1] = -1;
        attacked_piece = 0;
        changed_to_king = false;
}

void Move::set(int first_x, int first_y, int second_x, int second_y) {
        first[0]  = first_x;
        first[1]  = first_y;
        second[0] = second_x;
        second[1] = second_y;
        attacked_piece = 0;
        changed_to_king = false;
        return;
}

int Move::len() {
        if ((first[0]-second[0])>=0)
                return (first[0]-second[0]);
        return (second[0]-first[0]);
}

bool Move::_changed_to_king() {
    return changed_to_king;
}

bool Move::continue_attack(Move & next) {
    if (len()!=2)
        return false;
    return ((next.first[0]!=second[0])||(next.first[1]!=second[1]));
}

bool Move::is_valid(Board & cur_board) {
        if ((first[0]<0)||(first[0]>=8)||(first[1]<0)||(first[1]>=8))
                return false;
        if ((second[0]<0)||(second[0]>=8)||(second[1]<0)||(second[1]>=8))
                return false;
        if ((cur_board.piece(first[0], first[1])*cur_board.turn_player())<=0)
                return false;
        if (cur_board.piece(second[0], second[1]))
                return false;
        if ((cur_board.piece(first[0], first[1])*cur_board.turn_player())==1)
                if (((second[0]-first[0])*cur_board.turn_player())<0)
                        return false;
        if ((len()==2)&&((cur_board.piece((first[0]+second[0])/2, (first[1]+second[1])/2)*cur_board.turn_player())>=0))
                return false;
        return true;
}

bool Move::is_valid_input(Board & cur_board) {
        if (((first[0]-second[0])!=(first[1]-second[1]))&&((first[0]-second[0])!=(second[1]-first[1])))
                return false;
        if ((len()!=1)&&(len()!=2))
                return false;
        return is_valid(cur_board);
}

void Move::do_move(Board & cur_board) {
        cur_board.put(second[0], second[1], cur_board.piece(first[0], first[1]));
        cur_board.remove_piece(first[0], first[1]);
        if (len()==2) {
                attacked_piece = cur_board.piece((first[0]+second[0])/2, (first[1]+second[1])/2);
                cur_board.remove_piece((first[0]+second[0])/2, (first[1]+second[1])/2);
        }
        if (cur_board.turn_player()==1) {
                if ((second[0]==7)&&(cur_board.piece(second[0], second[1])==1)) {
                        changed_to_king = true;
                        cur_board.put(second[0], second[1], 2);
                }
        } else {
                if ((second[0]==0)&&(cur_board.piece(second[0], second[1])==-1)) {
                        changed_to_king = true;
                        cur_board.put(second[0], second[1], -2);
                }
        }
        return;
}

void Move::undo_move(Board & cur_board) {
        cur_board.put(first[0], first[1], cur_board.piece(second[0], second[1]));
        cur_board.put(second[0], second[1], 0);
        if (len()==2) {
                cur_board.put((first[0]+second[0])/2, (first[1]+second[1])/2, attacked_piece);
                attacked_piece = 0;
        }
        if (changed_to_king)
                cur_board.put(first[0], first[1], cur_board.piece(first[0], first[1])-cur_board.turn_player());
        changed_to_king = false;
        return;
}

void Move::do_move_player(Board & cur_board) {
        cout<<first[0]<<" "<<first[1]<<" "<<second[0]<<" "<<second[1]<<endl;
        do_move(cur_board);
        return;
}
