#ifndef PLAYER_H
#define PLAYER_H

#include <vector>

#include "move.h"

class Player {

        private:

                bool is_computer;

                int MAX_LEVEL;

        public:

                // Used in input_move :

                int _attack_;

                Move last_move;

                // FUNCTIONS:

                Player();

                void set(bool _is_computer);

                bool is_computer_player();

                // HELPING FUNCTIONS :

                int find_max_level(Board & cur_board);

                int my_inf(Board & cur_board);

                bool can_attack_piece(Board & cur_board, int row, int col);

                bool can_attack(Board & cur_board);

                bool is_finished(Board & cur_board);

                // FINDING VALUE :

                int find_value_attack_piece(Board & cur_board, int row, int col, int level, int alpha, int beta);

                int find_value_attack(Board & cur_board, int level, int alpha, int beta);

                int find_value_without_attack(Board & cur_board, int level, int alpha, int beta);

                int find_value(Board & cur_board, int level, int alpha, int beta);

                // FINDING BEST MOVE :

                int find_best_attack_piece(Board & cur_board, int row, int col, int level, int alpha, int beta, vector<Move> & best_move);

                bool find_best_attack(Board & cur_board, int level);

                bool find_best_without_attack(Board & cur_board, int level);

                int input_move(int first_0, int first_1, int second_0, int second_1 , Board & cur_board);

                bool play(Board & cur_board);

                void set_difficulty(int x);

};

#endif // PLAYER_H
